/*
 * include/asm-arm/arch-ns9xxx/debug-macro.S
 * Copyright (C) 2006 by Digi International Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */

/* XXX: verify functionallity */

#include <asm/arch/hardware.h>

#include <asm/arch-ns9xxx/regs-board-a9m9750dev.h>

#include <asm/arch/ns9750_ser.h>


@ 		.macro	addruart,rx
@ 		mrc	p15, 0, \rx, c1, c0
@ 		tst	\rx, #1					@ MMU enabled?
@ 		ldreq	\rx, =NS9XXX_CSxSTAT_PHYS(0)		@ physical
@ 		ldrne	\rx, =io_p2v(NS9XXX_CSxSTAT_PHYS(0))	@virtual
@ 		.endm

		.macro	addruart,rx
		mrc	p15, 0, \rx, c1, c0
		tst	\rx, #1			@ MMU enabled?
@		moveq	\rx, #0x90000000 @ physical base address
@		addeq   \rx, \rx, #0x00200000
@		movne	\rx, #0xf0000000	@ virtual base
@		addne	\rx, \rx, #(0x90000000) >> 4
@		addne   \rx, \rx, #(0x00200000) >> 4
		moveq	\rx, #0x90000040 @ physical base address
		addeq   \rx, \rx, #0x00200000
		movne	\rx, #0xf0000040	@ virtual base
		addne	\rx, \rx, #(0x90000000) >> 4
		addne   \rx, \rx, #(0x00200000) >> 4
		
		.endm

		.macro	senduart,rd,rx
		strb	\rd, [\rx, #(0x10)] @NS_SER_FIFO
		.endm

		.macro	waituart,rd,rx
1001:		ldr	\rd, [\rx, #(0x08)] @NS_SER_STAT_A
		tst	\rd, #NS_SER_STAT_A_RFULL
		bne	1001b
		.endm

		.macro	busyuart,rd,rx
		.endm



@#define UART_SHIFT	2
@#include <asm/hardware/debug-8250.S>
