/*
 * include/asm-arm/arch-ns9xxx/lcd_lib/custom.h
 *
 * Copyright (C) 2006 by Digi International Inc.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */

#ifndef __NS9XXX_LCDLIB_CUSTOM_VGA_H
#define __NS9XXX_LCDLIB_CUSTOM_VGA_H

#include <asm/arch/regs-lcd.h>
#include <asm/arch/hardware.h>


#define	DISP_NAME		"custom"

#error To use a custom display you have to edit and configure this file
#error Define the values for the timing/control registers accord to your
#error displays settings. Customize also the gpios settings and the power
#error enable/disable functions. See examples in this directory

// #define	DISP_XSIZE		(640)
// #define	DISP_YSIZE		(480)
//
// #define	DISP_CLK		DISP_USE_EXT_CLK /* Display clock frequency in HZ or DISP_USE_EXT_CLK */
//
// #define DISP_TIMING0		(LCD_TIMING_0_HBP( 40 ) | \
// 				 LCD_TIMING_0_HFP( 8 ) | \
// 				 LCD_TIMING_0_HSW( 96 ) | \
// 				 LCD_TIMING_0_PPL( (DISP_XSIZE/16)-1 ))
//
// #define DISP_TIMING1		(LCD_TIMING_1_VBP( 25 ) | \
// 				 LCD_TIMING_1_VFP( 2 ) | \
// 				 LCD_TIMING_1_VSW( 2 ) | \
// 				 LCD_TIMING_1_LPP( DISP_YSIZE-1))
//
// #define DISP_TIMING2		(LCD_TIMING_2_CPL( DISP_XSIZE-1 ) | \
// 				 LCD_TIMING_2_BCD | \
// 				 LCD_TIMING_2_IPC | \
// 				 LCD_TIMING_2_IHS | \
// 				 LCD_TIMING_2_IVS)
//
// #define DISP_TIMING3		(0x0)
//
// #define DISP_CONTROL		(LCD_CONTROL_WATERMARK | \
// 				 LCD_CONTROL_PWR | \
// 				 LCD_CONTROL_TFT | \
// 				 LCD_CONTROL_BGR | \
// 				 LCD_CONTROL_BPP_16 | \
// 				 LCD_CONTROL_EN)
//
// /*
//  * Specific GPIO configuration for the selected display
//  */
// struct ns9xxxfb_gpio ns9xxxfb_gpios[] = {
// 	 { 18, GPIO_CFG_OUTPUT },
// 	 { 15, GPIO_CFG_FUNC_2 },
// 	 { 19, GPIO_CFG_FUNC_1 },
// 	 { 20, GPIO_CFG_FUNC_1 },
// 	 { 21, GPIO_CFG_FUNC_1 },
// 	 { 22, GPIO_CFG_FUNC_1 },
// 	 { 24, GPIO_CFG_FUNC_1 },
// 	 { 25, GPIO_CFG_FUNC_1 },
// 	 { 26, GPIO_CFG_FUNC_1 },
// 	 { 27, GPIO_CFG_FUNC_1 },
// 	 { 28, GPIO_CFG_FUNC_1 },
// 	 { 29, GPIO_CFG_FUNC_1 },
// 	 { 30, GPIO_CFG_FUNC_1 },
// 	 { 31, GPIO_CFG_FUNC_1 },
// 	 { 32, GPIO_CFG_FUNC_2 },
// 	 { 33, GPIO_CFG_FUNC_2 },
// 	 { 34, GPIO_CFG_FUNC_2 },
// 	 { 35, GPIO_CFG_FUNC_2 },
// 	 { 36, GPIO_CFG_FUNC_2 },
// 	 { 37, GPIO_CFG_FUNC_2 },
// 	 { 38, GPIO_CFG_FUNC_2 },
// 	 { 39, GPIO_CFG_FUNC_2 },
// 	 { 40, GPIO_CFG_FUNC_2 },
// 	 { 41, GPIO_CFG_FUNC_2 }
// };
//
//
// /*
//  * Customize following functions to enable/disable the lcd
//  */
// void ns9xxxfb_lcd_power_enable(void)
// {
// 	(void)ns9xxx_gpio_setpin(23, 1);
// }
//
// void ns9xxxfb_lcd_power_disable(void)
// {
// 	(void)ns9xxx_gpio_setpin(23, 0);
// }

#endif /* __NS9XXX_LCDLIB_CRT_VGA_H */








